# Developers

- [JavaScript](https://docs.appmachine.com/developers/javascript.md): Add functionality in your app via JavaScript
- [Develop locally](https://docs.appmachine.com/developers/javascript/develop-locally.md): How to build your JavaScript app
- [SDK](https://docs.appmachine.com/developers/javascript/sdk.md): @myjsblock/sdk
- [Core](https://docs.appmachine.com/developers/javascript/sdk/core.md): Core JavaScript features
- [JS Data](https://docs.appmachine.com/developers/javascript/sdk/js-data.md): Data is the driving force behind your app. Integrate your custom JavaScript code with the web services in your app using these functions.
- [Media](https://docs.appmachine.com/developers/javascript/sdk/media.md): Allow users to share device media with your custom JavaScript code.
- [Navigation](https://docs.appmachine.com/developers/javascript/sdk/navigation.md): Give the user a tour of your beautiful app using the navigation functions.
- [Notification](https://docs.appmachine.com/developers/javascript/sdk/notification.md): Engage with your users by using our notification and dialog functions.
- [User](https://docs.appmachine.com/developers/javascript/sdk/user.md): Develop user-specific features to interact with your users on a closer level.
- [CLI](https://docs.appmachine.com/developers/javascript/cli.md): @myjsblock/cli
- [CLI Token and Secret](https://docs.appmachine.com/developers/javascript/cli/cli-token-and-secret.md): This article explains where to find and/or renew the token and secret required to enable updating the JavaScript block's code via the Command Line Interface (CLI).
- [Errors](https://docs.appmachine.com/developers/javascript/cli/errors.md)
- [CONFIG\_PROPERTIES\_INVALID](https://docs.appmachine.com/developers/javascript/cli/errors/config_properties_invalid.md): Config properties are invalid
- [CONFIG\_VALUES\_INVALID](https://docs.appmachine.com/developers/javascript/cli/errors/config_values_invalid.md): Config values are invalid
- [ENTRY\_FILE\_NOT\_FOUND](https://docs.appmachine.com/developers/javascript/cli/errors/entry_file_not_found.md): The entry file: {entryFile}, is not found in: {outputDirectory}
- [OUTPUT\_DIRECTORY\_IS\_EMPTY](https://docs.appmachine.com/developers/javascript/cli/errors/output_directory_is_empty.md): The configured output directory is empty: {{outputDirectory}}
- [OUTPUT\_DIRECTORY\_NOT\_FOUND](https://docs.appmachine.com/developers/javascript/cli/errors/output_directory_not_found.md): The configured output directory is not found: {{outputDirectory}}
- [TOKEN\_SECRET\_NOT\_PROVIDED](https://docs.appmachine.com/developers/javascript/cli/errors/token_secret_not_provided.md): No secret or token provided.
- [TOKEN\_SECRET\_NOT\_VALID](https://docs.appmachine.com/developers/javascript/cli/errors/token_secret_not_valid.md): The token or secret is not valid.
- [Migrate from old Custom JS](https://docs.appmachine.com/developers/javascript/migrate-from-old-custom-js.md): Actions required for classic apps to start using the new JS block
- [Web services](https://docs.appmachine.com/developers/web-services.md): Connect to external web services to add data to your app


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.appmachine.com/developers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
